﻿KPS = LibStub("AceAddon-3.0"):NewAddon("Profiles: Keyboard binds", "AceConsole-3.0", "AceEvent-3.0","AceTimer-3.0")
KPS:SetDefaultModuleState(false)

AceGUI = LibStub("AceGUI-3.0")


-- Globals within this addon
local KPSversion = "1.7.4"
local KPSdebugframe = 0
local KPSdebugbuffer = {}
local KLSdebugEnabled = 0
local run_counter = {}      -- Global for routines to not run more than once, modified by event_throttle() ONLY!
local update_bindings_counter = 0 -- UPDATE_BINDINGS event must not run first time

function KPS:Echo(text)
   DEFAULT_CHAT_FRAME:AddMessage("KPS: "..text)
end


function KPS:OnInitialize()
   
    KPSdb = LibStub("AceDB-3.0"):New("ProfilesKeyboardbinds",nil,"Default")
    KPS:SetupOptions()
	
        -- Check if we have are supposed to load the addon
    if KPSdb.char.KLSaddonEnabled == 0 then 
        KPS:Disable()
    else
        KPS:Enable()
    end
end

-- Addon loaded
function KPS:OnEnable()
KPS:DebugMsg("Core: OnEnable()")
    
    KLSdebugEnabled = KPSdb.char.KLSdebugEnabled or 0
    KPS:DebugWindowToggle(KLSdebugEnabled)
    
    DEFAULT_CHAT_FRAME:AddMessage("Profiles: Keyboard binds v"..KPSversion.." ON")
    
    if KPSdb.char.KLSaddonEnabled == nil then
        KPSdb.char.KLSaddonEnabled = 1
    end
    
    KPSdb.char.KLStriggerModule = KPSdb.char.KLStriggerModule or "KPS: Talents"
    KPS:DebugMsg("Core: OnEnable() - Loading trigger module -"..KPSdb.char.KLStriggerModule.."-") 
    
    KPS:EnableModule(KPSdb.char.KLStriggerModule)
    KPS:RegisterEvent("UPDATE_BINDINGS")
    
    -----------------------------------------------------
	-- Unregister UPDATE_BINDINGS if we go into combat. -
	-----------------------------------------------------
    KPS:RegisterEvent("PLAYER_ENTER_COMBAT") -- Are we in combat? Disable UPDATE_BINDINGS!
    KPS:RegisterEvent("PLAYER_REGEN_DISABLED")
    
    KPS:RegisterEvent("PLAYER_LEAVE_COMBAT") -- Enable UPDATE_BINDINGS if we exit the fight
    KPS:RegisterEvent("PLAYER_REGEN_ENABLED")
    
   
end


-----------------------------------------------------
-- Unregister UPDATE_BINDINGS if we go into combat. -
-----------------------------------------------------
function KPS:PLAYER_ENTER_COMBAT()
--	KPS:DebugMsg("PLAYER_ENTER_COMBAT(): Entered")

    KPS:UnregisterEvent("UPDATE_BINDINGS")
end

function KPS:PLAYER_LEAVE_COMBAT()
--	KPS:DebugMsg("PLAYER_LEAVE_COMBAT(): Entered")

    -- Register again as we have now exited combat!
    update_bindings_counter = 0 -- Do not run the first time after we register this event!
    KPS:RegisterEvent("UPDATE_BINDINGS")
end

function KPS:PLAYER_REGEN_DISABLED()
--	KPS:DebugMsg("PLAYER_REGEN_DISABLED(): Entered")

    KPS:UnregisterEvent("UPDATE_BINDINGS")
end

function KPS:PLAYER_REGEN_ENABLED()
--	KPS:DebugMsg("PLAYER_REGEN_ENABLED(): Entered")

    -- Register again as we have now exited combat!
    update_bindings_counter = 0 -- Do not run the first time after we register this event!
    KPS:RegisterEvent("UPDATE_BINDINGS")
end

-- Toggle a named module.
-- If no module is passed to this routine, it shuts off all modules 
-- and sets KPS: Talents as default
function KPS:ModuleToggle(KPSmodule)
KPS:DebugMsg("ModuleToggle()")

    -- Empty named var, setting default
    if not KPSmodule then
        KPS:DebugMsg("ModuleToggle(): No module passed on. Setting default..")
        
        -- Disable all but default
        for name, module in KPS:IterateModules() do
        
        
            if name ~= "KPS: Talents" then
                KPS:DebugMsg("ModuleToggle(): Disabling -"..name.."-")
                KPS:DisableModule(name)
            end
        end
        
        KPSdb.char.KLStriggerModule = "KPS: Talents"
        KPS:EnableModule("KPS: Talents")
        
        return
    end
    
    -- This module is enabled, disable it now
    if KPSdb.char.KLStriggerModule == KPSmodule then
    KPS:DebugMsg("ModuleToggle(): This is already enabled. Now disabling -"..KPSmodule)
    
        -- Disable all but default
        for name, module in KPS:IterateModules() do
            if name ~= "KPS: Talents" then
                KPS:DebugMsg("ModuleToggle(): Disabling -"..name.."-")
                KPS:DisableModule(name)
            end
        end
        
        KPSdb.char.KLStriggerModule = "KPS: Talents"
        KPS:EnableModule("KPS: Talents")
        
        return
    end
    
    -- This module is disabled, try to enable it!
    
    -- Disable all but this module
    for name, module in KPS:IterateModules() do   
            if name ~= KPSmodule then
                KPS:DebugMsg("ModuleToggle(): Disabling -"..name.."-")
                KPS:DisableModule(name)
            else
                KPS:DebugMsg("ModuleToggle(): Enabling -"..KPSmodule.."-")
                
            end
    end
    
    KPS:DebugMsg("ModuleToggle(): This is disabled. Now enabling -"..KPSmodule)
    
    KPSdb.char.KLStriggerModule = KPSmodule
    
    if not KPS:EnableModule(KPSdb.char.KLStriggerModule) then
        KPS:DebugMsg("ModuleToggle(): Loading module '"..KPSdb.char.KLStriggerModule.."' failed. Reverting to 'KPS: Talents' module.")
        DEFAULT_CHAT_FRAME:AddMessage(KPSdb.char.KLStriggerModule.." failed to load. Setting default -KPS: Talents-")
        
        KPSdb.char.KLStriggerModule = "KPS: Talents"
        KPS:EnableModule("KPS: Talents")

        return
    else
        KPS:DebugMsg("ModuleToggle(): Module '"..KPSdb.char.KLStriggerModule.."' loaded.")
    end
end

function KPS:OnDisable()
KPS:DebugMsg("OnDisable()")
        
    DEFAULT_CHAT_FRAME:AddMessage("Profiles: Keyboard binds v"..KPSversion.." OFF")
   
    KPS:DebugMsg("OnDisable(): Unregistering modules")
    KPS:DisableModule(KPSdb.char.KLStriggerModule)
    
    KPSdb.char.KLSaddonEnabled = 0
    KPS:Disable()
end





function KPS:ExistsProfile(name)
--KPS:DebugMsg("ExistsProfile("..name..")")
   for i, k in ipairs(KPSdb:GetProfiles()) do
      local key = k
      
      if key == name then
         return (key)
      end
   end
   return nil
end

--User updated his keybinds
function KPS:UPDATE_BINDINGS(...) -- Should not fire first time!
	KPS:DebugMsg("UPDATE_BINDINGS()")
    
    -- UPDATE_BINDINGS event must not run first time
    if update_bindings_counter == 0 then
		KPS:DebugMsg("UPDATE_BINDINGS(): First time run, returning...")
		update_bindings_counter = 1
		return
    end
	
    KPS:DebugMsg("UPDATE_BINDINGS(): Saving keybinds for profile: -"..KPSdb:GetCurrentProfile().."-")
    KPS:SaveProfil(KPSdb:GetCurrentProfile())
end

function KPS:SaveProfil(name)

	if name == nil then
		name = KPSdb:GetCurrentProfile()
	end
	
	KPS:DebugMsg("SaveProfil("..name..")")

	-- Solving /kps save tank X 2
	if KPSdb:ExistsProfile(name) then KPSdb:ResetProfile(name) end
	
	KPSdb:SetProfile(name)
        
    -- Go through the actionbars  and save _defined_ keybinds// Thank you Adirelle
	for index = 1, GetNumBindings() do
	  local command, key1 = GetBinding(index)
	  
	  if key1 then
		-- This creates a table like { cmd = key1, key2, key3 }
		KPSdb.profile[command] = { key1, select(3, GetBinding(index)) }
	  else
		-- Remove previous bindings
		KPSdb.profile[command] = nil
	  end
	end  

end

function KPS:LoadProfil(name)
KPS:DebugMsg("LoadProfil("..name..")")

KPS:UnregisterEvent("UPDATE_BINDINGS")

	if (UnitAffectingCombat("player")~=nil)then -- if (player is in fight)
		KPS:Echo("You can t change your keyboardlayout in fight.")
	elseif (KPS:ExistsProfile(name)==nil)then
		KPS:Echo("-"..name.."- doesn t exist.")
	elseif (KPSdb:GetCurrentProfile()==name)then
		KPS:DebugMsg("LoadProfil(): "..name.." already loaded.")
	else
		KPS:DebugMsg("LoadProfil(): Setting profile "..name)
        KPSdb:SetProfile(name)
        
        -- To restore
		for command, keys in pairs(KPSdb.profile) do
            
            
            if command ~= "Reset" then 		
					local current_keys = {GetBindingKey(command)}       -- Current bindings -> UP/W
					local saved_keys = {}                               -- Saved bindings
					local binding_modified = 0                          -- Modified flag
					local current_keys_table = {}

					-- Transform to hash tables
					for i,v in pairs(KPSdb.profile[command]) do saved_keys[v]="1" end			 -- table[1]:W -> saved_keys[W]
					for i=1, #current_keys do  current_keys_table[current_keys[i]] = "1"  end    -- @table     -> current_keys_table[Q]

					-- Check saved <=> current hash
					for i,v in pairs (saved_keys) do
					   if not current_keys_table[i] then
						  binding_modified = 1
						  KPS:DebugMsg("LoadProfil(): .Key "..i.." was changed in saved profile.")
					   end
					end

					-- Check current <=> saved hash
					if (binding_modified == 0) then
					   for i,v in pairs (current_keys_table) do
						  if not saved_keys[i] then
							 binding_modified = 1    
							  KPS:DebugMsg("LoadProfil(): -Key "..i.." was changed in saved profile.")
						  end
					   end
					end
					
					-- Modified flag active!
					if binding_modified == 1 then
					KPS:DebugMsg("LoadProfil(): "..command.." was found changed. Now restoring..")
						-- Remove all current binds for this action (eg. MOVEFORWARD)
						for i,v in pairs (current_keys_table) do
						   --KPS:DebugMsg("LoadProfil(): +Key "..i.." was changed in saved profile.")
						   SetBinding(i)
						end
						-- Add all saved keys to this action
						for i,v in pairs (saved_keys) do
							SetBinding(i,command)
							--KPS:DebugMsg("LoadProfil(): >Key "..i.." was changed in saved profile.")
						end
						binding_modified = 0
				   end
			 end
		end          
                  
	end



    KPS:Echo("-"..name.."- loaded")
    SaveBindings(2)
    
KPS:RegisterEvent("UPDATE_BINDINGS")
end

function KPS:DeleteProfil(name)
KPS:DebugMsg("DeleteProfil("..name..")")

   if (KPS:ExistsProfile(name)==nil)then
      KPS:Echo("-"..name.."- doesnt exist.")
      KPS:ListProfiles()
   else
      KPSdb:SetProfile('Default')
      KPSdb:DeleteProfile(name)
      KPS:Echo("-"..name.."- deleted. Now using Default profile..")
   end
end

function KPS:ListProfiles()
KPS:DebugMsg("ListProfiles()")

    print("KPS: Available Profiles: ");
    
	for i,k in ipairs(KPSdb:GetProfiles()) do
		if k == KPSdb:GetCurrentProfile() then
			print(' - ' .. k.." (current)")
		else
			print(' - ' .. k)
		end
	end
end
SLASH_KPS1 = "/KPS"
SlashCmdList["KPS"] = function(msg)
   local cmd, arg = string.split(" ", msg, 2)
   cmd = string.lower(cmd or "")
   arg = arg or ""
   
   if (cmd == "version") then
      print("Profiles: Keyboard binds v."..KPSversion)
   elseif (cmd=="list")then
      KPS:ListProfiles()
   elseif (cmd=="" or arg=="")then
      KPS:Echo("/KPS delete <name>")
      KPS:Echo("/KPS save <name>")
      KPS:Echo("/KPS load <name>")
      KPS:Echo("/KPS list")
      KPS:Echo("/KPS version")
      KPS:Echo("/KPS debug [on|off]")
   elseif (cmd=="save" and arg~="")then
      KPS:SaveProfil(arg)
   elseif (cmd=="debug" and arg~="")then   
      if arg == "on" then
        KPS:DebugWindowToggle(1)
      else
        KPS:DebugWindowToggle(0)
      end
   elseif (cmd=="load" and arg~="")then
      KPS:LoadProfil(arg)
   elseif (cmd=="delete" and arg~="")then
      KPS:DeleteProfil(arg)
   
   else    
      KPS:Echo("wrong entry")
   end
end

function KPS:DebugWindowToggle(visible)
   if visible == 1 then
      KLSdebugEnabled = 1
      KPSdb.char.KLSdebugEnabled=1
      
      KPSdebugframe = AceGUI:Create("Frame")
      KPSdebugframe:SetTitle("Profiles: Keyboard binds Debug")
      KPSdebugframe:SetStatusText("To turn this window off: /kps debug off")
      KPSdebugframe:SetCallback("OnClose", function(widget) AceGUI:Release(widget) KLSdebugEnabled = 0 KPSdb.char.KLSdebugEnabled=0 KPS:DebugWindowToggle() end)
      KPSdebugframe:SetLayout("Fill")
      KPSdebugframe:SetWidth("400")
      KPSdebugframe:SetHeight("400")
      KPS:DebugMsg("DebugWindowToggle(1)")
   else
   KPS:DebugMsg("DebugWindowToggle(0)")
      if KLSdebugEnabled == 1 then
          KLSdebugEnabled = 0
          KPSdb.char.KLSdebugEnabled=0
          KPSdebugframe:Release()
      end
   end
   
end

function KPS:DebugMsg(debugMessage)
   if KPSdebugbuffer == 0 then
      debugMessage = date("%H:%M:%S").." - DEBUGGER Loaded"
      table.insert(KPSdebugbuffer,debugMessage)
      
   else
      debugMessage = date("%H:%M:%S").." - "..debugMessage
      table.insert(KPSdebugbuffer,debugMessage)
   end
  
    if KLSdebugEnabled ~= 1 then 
        KPSdebugbuffer = circular_list(KPSdebugbuffer,50) -- Save 20 debug messages by default, even with debug turned off.
        return
    end
    
   KPSdebugframe:ReleaseChildren() -- Refresh textbox
   
   local editbox = AceGUI:Create("MultiLineEditBox")
   editbox:SetNumLines(10)
   local KPSdebugbuffervariable = "\n"
   for _,value in ipairs(KPSdebugbuffer) do 
        KPSdebugbuffervariable =  KPSdebugbuffervariable..value.."\n" 
   end
   editbox:SetText(KPSdebugbuffervariable)
   editbox:DisableButton(1)
   KPSdebugframe:AddChild(editbox)
end

-- Give this function a list_objec = {} and max amount of entries in that table
-- and it will remove them for you
function circular_list(list_object,list_max)

   if (#list_object > list_max)then
      while #list_object > list_max do 
         table.remove(list_object,1)
      end
   end
   
   return list_object
   
end

-- WoW Events are quite crazy, firing all over the place.
-- Give this function a the event and how many times per second
-- it is allowed to fire and it will return "IGNORE" if that event has gone haywire.
-- NOTE: global event_throttle_list will be needed for this function
-- NOTE 2: Should be called from the event itself
function event_throttle (event,localtime,seconds_threshold)

	-- Register the event
	--if 	run_counter[event] then
	--run_counter[times_run]++
	--run_counter[event] = { localtime = localtime, times_run = 0 }

end